package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, string-based, split-first approach with renamed methods and
 * variables.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAA2 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		ArrayList<String> seperation = seperate(sentence);
		for (String word : seperation) {
			if (!checkForPalindrome(word)) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> seperate(String inputString) {
		ArrayList<String> substrings = new ArrayList<String>();
		int startPosition = 0;
		for (int i = 0; i < inputString.length(); i++) {
			if (inputString.charAt(i) == ' ') {
				substrings.add(inputString.substring(startPosition, i));
				startPosition = i + 1;
			}
		}
		substrings.add(inputString.substring(startPosition, inputString.length()));
		return substrings;
	}

	public boolean checkForPalindrome(String inputString) {
		return inputString.equals(turnAround(inputString));
	}

	public String turnAround(String inputString) {
		StringBuilder reversedWord = new StringBuilder();
		for (int i = inputString.length() - 1; i >= 0; i--) {
			reversedWord.append(inputString.charAt(i));
		}
		return reversedWord.toString();
	}
}
