package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, string-based, split-first approach with changed order of
 * operations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAA4 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		ArrayList<String> split = split(sentence);
		for (String word : split) {
			if (!isPalindrome(word)) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> split(String sentence) {
		int wordStart = 0;
		ArrayList<String> words = new ArrayList<String>();
		for (int i = 0; i < sentence.length(); i++) {
			if (' ' == sentence.charAt(i)) {
				words.add(sentence.substring(wordStart, i));
				wordStart = i + 1;
			}
		}
		words.add(sentence.substring(wordStart, sentence.length()));
		return words;
	}

	public boolean isPalindrome(String word) {
		return reverse(word).equals(word);
	}

	public String reverse(String word) {
		StringBuilder builder = new StringBuilder();
		for (int i = word.length() - 1; i >= 0; i--) {
			builder.append(word.charAt(i));
		}
		return builder.toString();
	}
}
