package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, string-based, split-first approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAA5 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		ArrayList<String> split;
		split = split(sentence);
		boolean allWordsArePalindromes = true;
		for (String word : split) {
			boolean isPalindrome = isPalindrome(word);
			allWordsArePalindromes = allWordsArePalindromes && isPalindrome;
			if (!allWordsArePalindromes) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> split(String sentence) {
		ArrayList<String> words;
		words = new ArrayList<String>();
		int wordStart;
		wordStart = 0;
		int sentenceLength = sentence.length();
		for (int i = 0; i < sentenceLength; i++) {
			char currentChar = sentence.charAt(i);
			if (currentChar == ' ') {
				String currentWord = sentence.substring(wordStart, i);
				words.add(currentWord);
				wordStart = i + 1;
			}
		}
		String lastWord = sentence.substring(wordStart, sentenceLength);
		words.add(lastWord);
		return words;
	}

	public boolean isPalindrome(String word) {
		String reversedWord = reverse(word);
		boolean isPalindrome = word.equals(reversedWord);
		return isPalindrome;
	}

	public String reverse(String word) {
		StringBuilder builder = new StringBuilder();
		int wordLength = word.length();
		for (int i = wordLength - 1; i >= 0; i--) {
			char currentChar = word.charAt(i);
			builder.append(currentChar);
		}
		return builder.toString();
	}
}
