package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.Stack;

/**
 * own method, string-based, iterative approach.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAB implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Stack<Character> characters = new Stack<Character>();
		int wordStart = 0;
		for (int i = 0; i < sentence.length(); i++) {
			Character character = sentence.charAt(i);
			if (character == ' ') {
				if (!checkForPalindrome(characters, sentence, wordStart,
						(wordStart + i) / 2)) {
					return false;
				}
				wordStart = i + 1;
				characters.clear();
			} else {
				characters.push(character);
			}
		}
		return checkForPalindrome(characters, sentence, wordStart, (wordStart +
				sentence.length() - 1) / 2);
	}

	private boolean checkForPalindrome(Stack<Character> stack, String sentence,
			int startIndex, int endIndex) {
		for (int j = startIndex; j <= endIndex; j++) {
			if (!stack.pop().equals(sentence.charAt(j))) {
				return false;
			}
		}
		return true;
	}
}
