package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.Stack;

/**
 * own method, string-based, iterative approach with changed
 * variable names.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAB2 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		int currentWordStart = 0;
		Stack<Character> currentWordChars = new Stack<Character>();
		for (int i = 0; i < sentence.length(); i++) {
			Character currentChar = sentence.charAt(i);
			if (currentChar == ' ') {
				if (!isPalindrome(currentWordChars, sentence, currentWordStart,
						(currentWordStart + i) / 2)) {
					return false;
				}
				currentWordStart = i + 1;
				currentWordChars.clear();
			} else {
				currentWordChars.push(currentChar);
			}
		}
		return isPalindrome(currentWordChars, sentence, currentWordStart,
				(currentWordStart + sentence.length() - 1) / 2);
	}

	private boolean isPalindrome(Stack<Character> reversedChars, String input,
			int wordStart, int wordEnd) {
		for (int j = wordStart; j <= wordEnd; j++) {
			if (!reversedChars.pop().equals(input.charAt(j))) {
				return false;
			}
		}
		return true;
	}
}