package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.Stack;

/**
 * own method, string-based, iterative approach with changed order of
 * operations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAB4 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		int wordStart = 0;
		Stack<Character> characters = new Stack<Character>();
		for (int i = 0; i < sentence.length(); i++) {
			Character character = sentence.charAt(i);
			if (' ' == character) {
				if (!checkForPalindrome(characters, sentence, wordStart,
						(wordStart + i) / 2)) {
					return false;
				}
				characters.clear();
				wordStart = i + 1;
			} else {
				characters.push(character);
			}
		}
		return checkForPalindrome(characters, sentence, wordStart, (wordStart
				+ sentence.length() - 1) / 2);
	}

	private boolean checkForPalindrome(Stack<Character> stack, String sentence,
			int startIndex, int endIndex) {
		for (int j = startIndex; j <= endIndex; j++) {
			if (!(new Character(sentence.charAt(j)).equals(stack.pop()))) {
				return false;
			}
		}
		return true;
	}
}
