package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.Stack;

/**
 * own method, string-based, iterative approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplAAB5 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Stack<Character> characters = new Stack<Character>();
		int wordStart = 0;
		int sentenceLength = sentence.length();
		for (int i = 0; i < sentenceLength; i++) {
			Character character = sentence.charAt(i);
			if (character == ' ') {
				int halfWordPosition = (wordStart + i) / 2;
				if (!checkForPalindrome(characters, sentence, wordStart,
						halfWordPosition)) {
					return false;
				}
				wordStart = i + 1;
				characters.clear();
			} else {
				characters.push(character);
			}
		}
		int halfLastWordPosition = (wordStart + sentence.length() - 1) / 2;
		return checkForPalindrome(characters, sentence, wordStart, halfLastWordPosition);
	}

	private boolean checkForPalindrome(Stack<Character> stack, String sentence,
			int startIndex, int endIndex) {
		for (int j = startIndex; j <= endIndex; j++) {
			char currentChar = sentence.charAt(j);
			Character currentReversedChar = stack.pop();
			if (!currentReversedChar.equals(currentChar)) {
				return false;
			}
		}
		return true;
	}
}
