package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, array-based, split-first approach with renamed methods and
 * variables.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABA2 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String input) {
		ArrayList<String> seperatedStrings = seperate(input);
		for (String substring : seperatedStrings) {
			if (!checkForPalindrome(substring)) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> seperate(String inputString) {
		ArrayList<String> substrings = new ArrayList<String>();
		char[] stringChars = inputString.toCharArray();
		int wordStart = 0;
		for (int i = 0; i < stringChars.length; i++) {
			if (stringChars[i] == ' ') {
				substrings.add(inputString.substring(wordStart, i));
				wordStart = i + 1;
			}
		}
		substrings.add(inputString.substring(wordStart, inputString.length()));
		return substrings;
	}

	public boolean checkForPalindrome(String string) {
		char[] stringChars = string.toCharArray();
		for (int i = 0; i < stringChars.length / 2; i++) {
			if (stringChars[i] != stringChars[stringChars.length - 1 - i]) {
				return false;
			}
		}
		return true;
	}
}
