package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, array-based, split-first approach with changed order of
 * declarations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABA3 implements SampleSolution {

	public boolean isPalindrome(String word) {
		char[] characters = word.toCharArray();
		for (int i = 0; i < characters.length / 2; i++) {
			if (characters[i] != characters[characters.length - 1 - i]) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> split(String sentence) {
		ArrayList<String> words = new ArrayList<String>();
		char[] characters = sentence.toCharArray();
		int wordStart = 0;
		for (int i = 0; i < characters.length; i++) {
			if (characters[i] == ' ') {
				words.add(sentence.substring(wordStart, i));
				wordStart = i + 1;
			}
		}
		words.add(sentence.substring(wordStart, sentence.length()));
		return words;
	}

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		ArrayList<String> split = split(sentence);
		for (String word : split) {
			if (!isPalindrome(word)) {
				return false;
			}
		}
		return true;
	}
}
