package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.ArrayList;

/**
 * own method, array-based, split-first approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABA5 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		ArrayList<String> split = split(sentence);
		boolean allWordsArePalindromes = true;
		for (String word : split) {
			boolean isPalindrome = isPalindrome(word);
			allWordsArePalindromes = allWordsArePalindromes && isPalindrome;
			if (!allWordsArePalindromes) {
				return false;
			}
		}
		return true;
	}

	public ArrayList<String> split(String sentence) {
		ArrayList<String> words = new ArrayList<String>();
		char[] characters = sentence.toCharArray();
		int arrayLength = characters.length;
		int wordStart = 0;
		for (int i = 0; i < arrayLength; i++) {
			char currentChar = characters[i];
			if (currentChar == ' ') {
				String currentWord = sentence.substring(wordStart, i);
				words.add(currentWord);
				wordStart = i + 1;
			}
		}
		String lastWord = sentence.substring(wordStart, arrayLength);
		words.add(lastWord);
		return words;
	}

	public boolean isPalindrome(String word) {
		char[] characters = word.toCharArray();
		int wordLength = characters.length;
		int halfWordLength = wordLength / 2;
		for (int i = 0; i < halfWordLength; i++) {
			if (characters[i] != characters[wordLength - 1 - i]) {
				return false;
			}
		}
		return true;
	}
}
