package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * own method, array-based, iterative approach.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABB implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		char[] characters = sentence.toCharArray();
		int wordStart = 0;
		for (int i = 0; i < characters.length; i++) {
			if (characters[i] == ' ') {
				if (!checkForPalindrome(characters, wordStart, i - wordStart - 1)) {
					return false;
				}
				wordStart = i + 1;
			}
		}
		return checkForPalindrome(characters, wordStart, characters.length -
				wordStart - 1);
	}

	private boolean checkForPalindrome(char[] characters,
			int startIndex, int wordLength) {
		for (int j = 0; j < wordLength / 2; j++) {
			if (characters[startIndex + j] != characters[startIndex + wordLength -
					j]) {
				return false;
			}
		}
		return true;
	}
}