package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * own method, array-based, iterative approach with renamed methods and
 * variables.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABB2 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String inputString) {
		char[] stringChars = inputString.toCharArray();
		int substringStart = 0;
		for (int currentCharIndex = 0;
				currentCharIndex < stringChars.length;
				currentCharIndex++) {
			if (stringChars[currentCharIndex] == ' ') {
				if (!isPalindrome(stringChars, substringStart, currentCharIndex
						- substringStart - 1)) {
					return false;
				}
				substringStart = currentCharIndex + 1;
			}
		}
		return isPalindrome(stringChars, substringStart, stringChars.length
				- substringStart - 1);
	}

	private boolean isPalindrome(char[] wordChars,
			int wordStartIndex, int wordLength) {
		for (int currentCharIndex = 0; currentCharIndex < wordLength / 2;
				currentCharIndex++) {
			if (wordChars[wordStartIndex + currentCharIndex]
					!= wordChars[wordStartIndex + wordLength - currentCharIndex]) {
				return false;
			}
		}
		return true;
	}
}