package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * own method, array-based, iterative approach with changed order of operations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABB4 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		int wordStart = 0;
		char[] characters = sentence.toCharArray();
		for (int i = 0; i < characters.length; i++) {
			if (' ' == characters[i]) {
				if (!checkForPalindrome(characters, wordStart, i - wordStart - 1)) {
					return false;
				}
				wordStart = i + 1;
			}
		}
		return checkForPalindrome(characters, wordStart, characters.length
				- wordStart - 1);
	}

	private boolean checkForPalindrome(char[] characters,
			int startIndex, int wordLength) {
		for (int j = 0; j < wordLength / 2; j++) {
			if (characters[startIndex + wordLength - j] != characters[startIndex + j]) {
				return false;
			}
		}
		return true;
	}
}