package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * own method, array-based, iterative approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplABB5 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		char[] characters = sentence.toCharArray();
		int wordStart = 0;
		int sentenceLength = characters.length;
		for (int i = 0; i < sentenceLength; i++) {
			char currentChar = characters[i];
			if (currentChar == ' ') {
				int wordLength = i - wordStart - 1;
				boolean isPalindrome = checkForPalindrome(characters, wordStart, wordLength);
				if (!isPalindrome) {
					return false;
				}
				wordStart = i + 1;
			}
		}
		int lastWordLength = sentenceLength - wordStart - 1;
		return checkForPalindrome(characters, wordStart, lastWordLength);
	}

	private boolean checkForPalindrome(char[] characters,
			int startIndex, int wordLength) {
		int halfWordLength = wordLength / 2;
		for (int j = 0; j < halfWordLength; j++) {
			char currentForwardChar = characters[startIndex + j];
			char currentBackwardchar = characters[startIndex + wordLength - j];
			if (currentForwardChar != currentBackwardchar) {
				return false;
			}
		}
		return true;
	}
}