package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * built-in, string based, split-first approach with comments.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBAA1 implements SampleSolution {

	/**
	 * Checks if all words of the given sentence are palindromes.
	 *
	 * @param sentence a sentence with words separated by a single whitespace.
	 * @return true if all words are palindromes and false otherwise.
	 */
	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		/* 
		 * split the sentence at whitespaces and iterate over all words
		 * in the sentence.
		 */
		for (String word : sentence.split(" ")) {
			/*
			 * Create a StringBuilder from the word, reverse its content,
			 * convert it back to a string and check if it is the same as the
			 * original word.
			 * If so it is a palindrome.
			 */
			if (!word.equals((new StringBuilder(word)).reverse().toString())) {
				//if not return false.
				return false;
			}
		}
		//if we got here all words are palindromes and we can return true.
		return true;
	}
}
