package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with renamed methods and
 * variables.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBAB2 implements SampleSolution {

	private static final Pattern PATTERNFORSUBSTRINGS = Pattern.compile("\\w+");

	@Override
	public boolean areAllWordsPalindromes(String inputString) {
		Matcher subStringFinder = PATTERNFORSUBSTRINGS.matcher(inputString);
		while (subStringFinder.find()) {
			String substring = subStringFinder.group();
			if (!substring.equals(
					(new StringBuilder(substring)).reverse().toString())) {
				return false;
			}
		}
		return true;
	}
}
