package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with changed order of operations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBAB4 implements SampleSolution {

	private static final Pattern wordPattern = Pattern.compile("\\w+");

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Matcher matcher = wordPattern.matcher(sentence);
		while (matcher.find()) {
			String word = matcher.group();
			if (!(new StringBuilder(word)).reverse().toString().equals(word)) {
				return false;
			}
		}
		return true;
	}
}
