package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBAB5 implements SampleSolution {

	private static final Pattern wordPattern = Pattern.compile("\\w+");

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Matcher matcher = wordPattern.matcher(sentence);
		while (matcher.find()) {
			String word = matcher.group();
			StringBuilder wordBuilder = new StringBuilder(word);
			StringBuilder reversedBuilder = wordBuilder.reverse();
			String reversedWord = reversedBuilder.toString();
			boolean isPalindrome = word.equals(reversedWord);
			if (!isPalindrome) {
				return false;
			}
		}
		return true;
	}
}
