package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * built-in, array-based, split-first approach with comments.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBBA1 implements SampleSolution {

	/**
	 * Checks if all words of the given sentence are palindromes.
	 *
	 * @param sentence a sentence with words separated by a single whitespace.
	 * @return true if all words are palindromes and false otherwise.
	 */
	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		//iterate over all words in the sentence separated by whitespaces.
		for (String word : sentence.split(" ")) {
			//transform the word to a character array.
			char[] characters = word.toCharArray();
			//iterate over the half word.
			for (int i = 0; i < characters.length / 2; i++) {
				//check if the word read forward is the same as read backwards.
				//if so it is a palindrome.
				if (characters[i] != characters[characters.length - 1 - i]) {
					//if not return false.
					return false;
				}
			}
		}
		//if all words are palindromes, return true.
		return true;
	}
}
