package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;

/**
 * built-in, array-based, split-first approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBBA5 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		String[] allWordsInTheSentence = sentence.split(" ");
		for (String word : allWordsInTheSentence) {
			char[] characters = word.toCharArray();
			int wordLength = characters.length;
			int halfWordLength = wordLength/ 2;
			for (int i = 0; i < halfWordLength; i++) {
				char currentForwardChar = characters[i];
				char currentBackwardChar = characters[wordLength - 1 - i];
				if (currentForwardChar != currentBackwardChar) {
					return false;
				}
			}
		}
		return true;
	}
}
