package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with renamed methods and
 * variables.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBBB2 implements SampleSolution {

	private static final Pattern PATTERNFORVALIDSUBSTRINGS =
			Pattern.compile("\\w+");

	@Override
	public boolean areAllWordsPalindromes(String inputString) {
		Matcher substringFinder = PATTERNFORVALIDSUBSTRINGS.matcher(inputString);
		while (substringFinder.find()) {
			char[] stringChars = substringFinder.group().toCharArray();
			for (int currentCharIndex = 0;
					currentCharIndex < stringChars.length / 2;
					currentCharIndex++) {
				if (stringChars[currentCharIndex]
						!= stringChars[stringChars.length - 1 - currentCharIndex]) {
					return false;
				}
			}
		}
		return true;
	}
}
