package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with changed order of
 * delcarations.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBBB3 implements SampleSolution {

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Matcher matcher = wordPattern.matcher(sentence);
		while (matcher.find()) {
			char[] characters = matcher.group().toCharArray();
			for (int i = 0; i < characters.length / 2; i++) {
				if (characters[i] != characters[characters.length - 1 - i]) {
					return false;
				}
			}
		}
		return true;
	}
	private static final Pattern wordPattern = Pattern.compile("\\w+");
}
