package de.unibi.citec.fit.javasamples.strategies;

import de.unibi.citec.fit.javasamples.SampleSolution;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * built-in, string-based, iterative approach with additional lines.
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class ImplBBB5 implements SampleSolution {

	private static final Pattern wordPattern = Pattern.compile("\\w+");

	@Override
	public boolean areAllWordsPalindromes(String sentence) {
		Matcher matcher = wordPattern.matcher(sentence);
		while (matcher.find()) {
			String currentWord = matcher.group();
			char[] characters = currentWord.toCharArray();
			int wordLength = characters.length;
			int halfWordLength = wordLength / 2;
			for (int i = 0; i < halfWordLength; i++) {
				char currentForwardChar = characters[i];
				char currentBackwardChar = characters[wordLength - 1 - i];
				if (currentForwardChar != currentBackwardChar) {
					return false;
				}
			}
		}
		return true;
	}
}
