/**
 * Strategies are characterized in three dimensions:
 * 
 * 1.) use of own methods (A) or built-in java ones (B).
 * 2.) String handling (A) vs. char-array-handling (B).
 * 3.) first split, then single word handling (A) or "stream based" approach (B).
 * 
 * Additionally there are trivial ("noise") variations of each combination which
 * are syntactically different but semantically equal (1 or 2 at the end).
 * 
 * 1 means that just comments where introduced.
 * 2 means that variable names were changed.
 * 3 means that the order of function and variable declarations were changed.
 * 4 means that the order of operations were changed without changing the 
 * actual semantic operation of the program.
 * 5 means that additional lines of code were introduced that do not change the 
 * semantic operation of the program.
 */
package de.unibi.citec.fit.javasamples.strategies;
